function [root,junction]=correct_skeleton(root,body,junction)
img=(body + junction) >0;
[x,y]=size(img);
new_root_pixels=zeros(size(body,1),size(body,2));
for i=1:max(max(root))
    
    %find the root pixel in the thin image.
    root_pixel=[];
    this_root=root==i;
    [co_x,co_y]=find(this_root);    
    for j=1:length(co_x)
        [nei_4,nei_84]=function_FindNeighbors(x,y,co_x(j),co_y(j));
        nei_8=[nei_4;nei_84];
        for k=1:size(nei_8,1)
            if img(nei_8(k,1),nei_8(k,2))>0
                root_pixel=[root_pixel;nei_8(k,1),nei_8(k,2)];
            end
        end
    end    
    root_pixel=unique(root_pixel,'rows');
        
    if ~isempty(root_pixel)
        
        %==================================================================
        % find the true connecting pixels and remove the neighbors
        neighbour_count = imfilter(uint8(body>0), ones(3));
        cc=[];
        for mm=1:size(root_pixel,1)
            if neighbour_count(root_pixel(mm,1),root_pixel(mm,2))<3
                cc=[cc,mm];
            end
        end
        if ~isempty(cc)
            root_pixel=root_pixel(cc,:);
            segment_point=[];
            branch_point=[];
            for ii=1:size(root_pixel,1)
                if body(root_pixel(ii,1),root_pixel(ii,2))~=0
                    segment_point=[segment_point;root_pixel(ii,:)];
                else
                    branch_point=[branch_point;root_pixel(ii,:)];
                end
            end
            
            dum_1=[];
            for ii=1:size(branch_point,1)
                dum_1(ii)=junction(branch_point(ii,1),branch_point(ii,2));
            end
            uniq_indx=function_uniq_indx(dum_1);
            branch_point=branch_point(uniq_indx,:);
            for ii=1:size(branch_point,1)
                if ~isempty(branch_point)
                    branch_num=junction(branch_point(ii,1),branch_point(ii,2));
                    this_branch=junction==branch_num;
                    junction(junction==branch_num)=0;
                    this_root=this_root | this_branch ;
                end
            end
            new_root_pixels=new_root_pixels | this_root;
            
        end
        
    else
        root(root==i)=0;
    end
   % new_root_pixels=new_root_pixels | this_root;
end
root=bwlabel(new_root_pixels>0);
junction=bwlabel(junction>0);
end

function uniq_indx=function_uniq_indx(dum_1)
if ~isempty(dum_1)
    uniq_id=unique(dum_1);
    
    for i=1:length(uniq_id)
       idx=find(dum_1==uniq_id(i));
       uniq_indx(i)=idx(1);
    end
else
    uniq_indx=[];
end
end