
% This function is to determine the status of given pixel (x,y) within a
% given bw image.

%----------------------------------------------------------------------------------------------
% By Yu Weimiao @ BII, Sept. 2008;
%-------------------------------------------------------

function [Status] = function_DetermineStatus(SKBW)
% 1: Dendrite BodyPoint
% 2: Dendrite NodePoint
% 3: Dendrite LeavePoint

[LX LY] = size(SKBW);
Status = zeros(LX,LY);

[xx yy] = find(SKBW==1);

% find out all well defined body points and leaf points
for i=1:1:length(xx)
%     i
    [FourNeighborXY, EightNeighborXY] = function_FindNeighbors(LX,LY,xx(i),yy(i));
%     figure(1);imagesc(SKBW);colormap gray;hold on;
%     plot(yy(i),xx(i),'k.')
%     plot(FourNeighbor(:,2),FourNeighbor(:,1),'r.');
%     plot(EightNeighbor(:,2),EightNeighbor(:,1),'b.');
    
    FourNeighborValue =[];
    for j=1:1:size(FourNeighborXY,1)
        FourNeighborValue = [FourNeighborValue; SKBW(FourNeighborXY(j,1),FourNeighborXY(j,2))];
    end
    
    EightNeighborValue =[];
    for j=1:1:size(EightNeighborXY,1)
        EightNeighborValue = [EightNeighborValue; SKBW(EightNeighborXY(j,1),EightNeighborXY(j,2))];
    end
    
    ValidFourNeighbor_ID = find(FourNeighborValue==1);
    ValidEightNeighbor_ID = find(EightNeighborValue==1);
    
    FourNeighbor = [];
    for j=1:1:length(ValidFourNeighbor_ID)
        FourNeighbor = [FourNeighbor; FourNeighborXY(ValidFourNeighbor_ID(j),1) FourNeighborXY(ValidFourNeighbor_ID(j),2)];
    end
%     FourNeighbor
    
    EightNeighbor = [];
    for j=1:1:length(ValidEightNeighbor_ID)
        EightNeighbor  = [EightNeighbor; EightNeighborXY(ValidEightNeighbor_ID(j),1) EightNeighborXY(ValidEightNeighbor_ID(j),2)];
    end
%     EightNeighbor
    
    NonValidEightNeighbor_ID=[];
    for j = 1:1: size(EightNeighbor,1)
        for k =1:1:size(FourNeighbor,1)
            SideBySide = function_SideBySide([EightNeighbor(j,1),EightNeighbor(j,2)], [FourNeighbor(k,1),FourNeighbor(k,2)]);
            if SideBySide ==1
                NonValidEightNeighbor_ID=[NonValidEightNeighbor_ID,j];
            end
        end
    end
    NonValidEightNeighbor_ID = unique(NonValidEightNeighbor_ID);
    EightNeighbor(NonValidEightNeighbor_ID, : ) = [];
    
    ValidNeighbors = [FourNeighbor;EightNeighbor];
    % leaf points:
    if size(ValidNeighbors,1)==0
        Status(xx(i),yy(i))=3;
    % leaf points:
    elseif size(ValidNeighbors,1)==1
        Status(xx(i),yy(i))=3;
    % body points:    
    elseif size(ValidNeighbors,1)==2
        Status(xx(i),yy(i))=1;
    % node points:
    elseif size(ValidNeighbors,1)>2
        Status(xx(i),yy(i))=2;
    else
        fprintf('\n Error\n')
    end
end
