
% This function is to return the coordinates of the pixel neighbers (4-neighbors and 
% 8-neighbor) of the given pixel (x,y) within LX by LY images

%----------------------------------------------------------------------------------------------
% By Yu Weimiao @ BII, Sept. 2008;
%-------------------------------------------------------

%|1 2 3|   FourNeighbor=[2 8 6 4];
%|8 X 4|   
%|7 6 5|   EightNeighbor=[1 7 5 3];


function [FourNeighbor, EightNeighbor] = function_FindNeighbors(LX,LY,x,y)

FourNeighbor =[x y-1;x-1,y;x y+1;x+1 y];

EightNeighbor = [ x-1 y-1; x-1 y+1; x+1 y+1;  x+1, y-1];

if x~=1 | x~=LX | y~=1 |  y~=LY

    KK=find(FourNeighbor(:,1)==0);FourNeighbor(KK,:)=[];
    KK=find(FourNeighbor(:,1)==LX+1);FourNeighbor(KK,:)=[];
    KK=find(FourNeighbor(:,2)==0);FourNeighbor(KK,:)=[];
    KK=find(FourNeighbor(:,2)==LY+1);FourNeighbor(KK,:)=[];

    KK=find(EightNeighbor(:,1)==0);  EightNeighbor(KK,:)=[];
    KK=find(EightNeighbor(:,1)==LX+1); EightNeighbor(KK,:)=[];
    KK=find(EightNeighbor(:,2)==0); EightNeighbor(KK,:)=[];
    KK=find(EightNeighbor(:,2)==LY+1); EightNeighbor(KK,:)=[];
end