function [W,pairAngle]=get_W_matrix(body,adj,node,junction_node)

%%Build the potential function
pairAngle = zeros(size(adj));
[adj_x , adj_y] = find(adj);
punishMatrix = zeros(size(adj));
for i = 1:length(adj_x)
    if(adj_x(i)>adj_y(i)) %avoid repeat
        continue;
    end
    for j=1:length(node(adj_x(i)).vertex)
        if any(node(adj_x(i)).vertex(j).segment == node(adj_y(i)).num)
            angle1 = node(adj_x(i)).vertex(j).Orientation;
            if length(node(adj_x(i)).vertex(j).segment)<=2 % when the branch has only 2 or 3 edges, we have different plans
                punishMatrix(adj_x(i),adj_y(i))=1;
            end
            break;
        end
    end
    for j=1:length(node(adj_y(i)).vertex)
        if any(node(adj_y(i)).vertex(j).segment == node(adj_x(i)).num)
            angle2 = node(adj_y(i)).vertex(j).Orientation;
            break;
        end
    end
    if abs(angle1-angle2) < pi
        pairAngle(adj_x(i),adj_y(i)) = abs(angle1-angle2);
    else
        pairAngle(adj_x(i),adj_y(i)) = pi*2 - abs(angle1-angle2);
    end
end

pairAngle = pairAngle + pairAngle';
punishMatrix = punishMatrix + punishMatrix';
similarity_1=zeros(size(adj,1));

%parameters set and model build
theta_c=60;
k=5;

for i=1:length(junction_node)
    connec_nodes=junction_node(i).ids;
    for c1=1:length(connec_nodes)
        for c2=c1:length(connec_nodes)
            
            theta=pairAngle(connec_nodes(c1),connec_nodes(c2));
            
            
            if (theta>=(acos(-sin(deg2rad(theta_c))/k^2)))
                similarity_1(connec_nodes(c1),connec_nodes(c2))=k*cos(theta);
                similarity_1(connec_nodes(c2),connec_nodes(c1))=k*cos(theta);
                
            elseif (theta<(acos(-sin(deg2rad(theta_c))/k^2)) && theta>=theta_c)
                similarity_1(connec_nodes(c1),connec_nodes(c2)) = -sin(theta_c)/k;
                similarity_1(connec_nodes(c2),connec_nodes(c1))= -sin(theta_c)/k;
            else
                similarity_1(connec_nodes(c1),connec_nodes(c2)) = -sin(theta)/k;
                similarity_1(connec_nodes(c2),connec_nodes(c1))= -sin(theta)/k;
            end
        end
    end
end


W=exp(-similarity_1);
W(adj==0)=0;



for i=1:length(junction_node)
    if length(junction_node(i).ids)==4
        co_or=junction_node(i).vertex;
        p1=[co_or(1,1),co_or(1,2)];
        p2=[co_or(2,1),co_or(2,2)];
        p3=[co_or(3,1),co_or(3,2)];
        p4=[co_or(4,1),co_or(4,2)];
        [group,point]=function_group_points(co_or);
        ids=[body(p1(1),p1(2)),body(p2(1),p2(2)),body(p3(1),p3(2)),body(p4(1),p4(2))];
        group=ids(group);
        W(group(1),group(3))=0.0 * W(group(1),group(3));
        W(group(3),group(1))=0.0 * W(group(3),group(1));
        W(group(1),group(4))=0.0 * W(group(1),group(4));
        W(group(4),group(1))=0.0 * W(group(4),group(1));
        W(group(2),group(4))=0.0 * W(group(2),group(4));
        W(group(4),group(2))=0.0 * W(group(4),group(2));
        W(group(2),group(3))=0.0 * W(group(2),group(3));
        W(group(3),group(2))=0.0 * W(group(3),group(2));
    end
end

end







