%Finding the nodes connected to each junction
%junction_node is a struct type
%junction_node.ids: the segment label connects to the junction.
%junction_node.num: the label of junction.
%junction_node.vertex: the vertex which is on the segment map (body) of the junction,maybe number of 2 or 3 or 4....
%junction_node.center: the center of the vertexs.
function junction_node=segment_attach_to_junction(body,junction)

bw_body=body>0;
junction_node=cell(0,0);

for i=1:max(max(junction))
    [id_x,id_y]=find(junction==i);
    ids=[];
    vertex=[];
    center=[];
    for j=1:length(id_x)
        [no,nei]=function_numofneighbours(id_x(j),id_y(j),bw_body);
        if ~isempty(nei)
            vertex=[vertex;nei];
            for k=1:no
                ids=[ids,body(nei(k,1),nei(k,2))];
            end
        end
    end
    
    if ~isempty(vertex) && size(vertex,1)>1
        center=round(mean(vertex));
    end
    
    junction_node(i).num=i;
    junction_node(i).ids=unique(ids);
    junction_node(i).vertex=vertex;
    junction_node(i).center=center;
    
end
end