%function for tracing
%input : seg: segmentation+soma
%output: soma: optical disk mask

function [trace_image,root_node,L,root_pixel,body,junction,adj,PairAngle]=trace_process(seg,soma)
%get the binary body and junction map of the input
[body,junction,root_node,root_pixel,root_label]=prepare_process(seg,soma);
[adj,Y,node,junction_node]=create_graph(body,junction,root_node);
[W,PairAngle]=get_W_matrix(body,adj,node,junction_node);
alpha=0.1;%10
[L,A]=function_MFTD_neuron(W,Y,alpha);
L=testtest(L,junction_node);
%get colour image
trace_image=save_color_image(root_node,L,body,junction);
end

function [body,junction,root_node,root_pixel,root_label]=prepare_process(seg,soma)
%thinning process
%bw_body: image of thin segmentation
%bw_junction: image of junction
%img: thin image with soma thin
%img_no_soma: thin image without soma
[bw_body,bw_junction,img,img_no_soma]=clean_skeleton(seg,soma);

%%used for neturon
% Removing extra cell bodies
% root = numbererd soma pixels
% root=remove_extra_soma(img,soma);

root=bwlabel(soma);

body=bwlabel(bw_body);
junction=bwlabel(bw_junction);

%root: label root clique
%junction: label junction image
[root,junction]=correct_skeleton(root,body,junction);

% Remove the small segment inside the crossovers
theta=110;%110
len=8;%8
[bw_body,bw_junction]=remove_small_segment(body,junction,root,theta,len);

body=bwlabel(bw_body);
junction=bwlabel(bw_junction);

[root_node,root_pixel,root_label]=find_root_segment_pixel(body,root);
end

function [new_adj,Y,node,junction_node]=create_graph(body,junction,root_node)

junction_node=segment_attach_to_junction(body,junction);
node=junction_attach_to_segment(body,junction,junction_node);

%junction_node is a struct type
%junction_node.ids: the segment label connects to the junction.
%junction_node.num: the label of junction.
%junction_node.vertex: the vertex which is on the segment map (body) of the junction,maybe number of 2 or 3 or 4....
%junction_node.center: the center of the vertexs.
%node is a struct type
%node.num: the label of segment.
%node.vertex: the vertex of this segment
%node.vertex.segment: the segments connect to this segment by this vertex.
%node.vertex(i).Orientation: the orientation of this segment in this vertex(i).
%node.ids: the junction connect to this segment

adj=find_adj(body,node,junction_node);
% new_adj=adj;
new_adj=find_direction_adj(adj,root_node,node,junction_node);

Y=zeros(size(new_adj,1),length(root_node));
for i=1:length(root_node)
    Y(root_node(i),i)=1;
end


end

function [L,A,fuck]=function_MFTD_neuron(W,Y,alpha)
W_norm=W/max(max(W));
w1=W;
%--------------------
W=W_norm';
D_dia_cap=sum(W,2);% ru du
L=diag(D_dia_cap)-W;
m=size(W,1);
MF=(eye(m)+alpha*L); % this is same as S^-1 in paper
s=inv(MF);
A=MF\Y; 

%----------------------
% W=w1;
% sum_W=sum(W,1);
% P=zeros(size(W));   
% for i=1:length(sum_W)
%     if sum_W(i)~=0
%         P(:,i)=W(:,i)/sum_W(i);
%     end
% end
% E=((1-alpha)*(eye(size(P,1))-alpha*P')^-1);
% E=(alpha/(1+alpha))*(eye(size(P,1))-(alpha/(1+alpha))*P')^-1;
% 
% A=E*Y;

[dum,L]=max(A,[],2);
sum_A=sum(A,2);
L(sum_A==0)=0;

end

function L=testtest(L,junction_node)


% sum_A=sum(A,2);
% L(sum_A==0)=0;
cc=0;
while ~isempty(find(L==0)) && cc<50
    cc=cc+1;
    for ii=1:length(junction_node)
        ids=junction_node(ii).ids;
        label_ids=L(ids);
        kk=setdiff(label_ids,0);
        if ~isempty(kk)
            L(ids(label_ids==0))=mode(kk);
        end
    end
end
end

